* {
    --color-bg-base: #1c1917;
    --color-text-primary: #fafaf9;
    --color-text-base: #d4d4d4;
    --color-text-secondary: #88827d;
    --color-surface: #44403c;
    --color-dimmed: #292524;
    --color-accent-1: #f87171;
    --color-accent-2: #ef4444;
    --spacing: 0.25rem;
    --content-width: 80rem;
    --wrapping-padding: 2rem;
    
    @media (width <= 40rem) {
        --wrapping-padding: 1rem;
    }
}

* {
    text-decoration: none;
    color: unset;
    font-family: ui-sans-serif, system-ui, sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol', 'Noto Color Emoji';
    box-sizing: border-box;
}

body {
    display: flex;
    flex-direction: column;
    height: 100vh;
    background: var(--color-bg-base);
    color: var(--color-text-base);
}

main {
    width: 100%;
    max-width: var(--content-width);
    margin: auto;
    padding: 8rem var(--wrapping-padding) 12rem var(--wrapping-padding);
    font-size: 1.5rem;
    line-height: 1.8;
}

main h1 {
    font-weight: 800;
    font-size: 2.5em;
    color: var(--color-text-primary);
    line-height: 1;

    @media (width <= 40rem) {
        font-size: 2em;
    }
}

main h2 {
    font-weight: bold;
    font-size: 1.8em;
    margin-top: 1.6em;
    margin-bottom: 0.85em;
    color: var(--color-text-primary);

    @media (width <= 40rem) {
        font-size: 1.5em;
    }
}

main h3 {
    color: var(--color-text-primary);
}

main p {
    margin-top: 1.2em;
    margin-bottom: 1.2em;
}

header nav {
    display: flex;
    flex-wrap: wrap;
    align-items: center;
    justify-content: space-between;
    gap: calc(var(--spacing) * 4);
    padding: calc(var(--spacing) * 8) var(--wrapping-padding);
    margin: 0 auto;
    max-width: var(--content-width);
}

header .logo {
    font-size: 1.5rem;
    font-weight: bold;
    background: linear-gradient(135deg, var(--color-accent-1) 0%, var(--color-accent-2) 100%);
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
}

header .links {
    display: flex;
    align-items: center;
    gap: calc(var(--spacing) * 6);
    list-style: none;
    padding: 0;
}

header a {
    font-size: 1.25rem;
    font-weight: bold;
    color: var(--color-text-primary);
}

header a:hover {
    color: var(--color-accent-1);
}

.card {
    display: flex;
    align-items: center;
    justify-content: space-between;
    color: var(--color-text-base);
    border: 1px solid var(--color-surface);
    padding: calc(var(--spacing) * 6);
}

.card-content {
    display: flex;
    flex-direction: column;
}

.card-link .card-content,
.card-project .card-content {
    gap: calc(var(--spacing) * 2);
}

.card-blog .card-content {
    gap: calc(var(--spacing) * 6);
}

.card h3, .card p {
    margin: 0;
}

.card .icon {
    display: flex;
    justify-content: end;
    min-width: calc(var(--spacing) * 8);
    transition: transform .2s ease;
}

.card-blog .read-more {
    color: var(--color-text-secondary);
}

.card:hover {
    border-color: var(--color-text-primary);
    color: var(--color-text-primary);
}

.card:hover .icon {
    transform: translateX(4px);
}

.card-list {
    display: flex;
    flex-direction: column;
    gap: calc(var(--spacing) * 6);
    margin-top: 6em;
}

.card-grid {
    display: grid;
    grid-template-columns: repeat(1, minmax(0, 1fr));
    gap: calc(var(--spacing) * 4);

    @media (width >= 40rem) {
      grid-template-columns: repeat(2, minmax(0, 1fr));
    }
}

footer {
    color: var(--color-text-base);
    border-top: 1px solid var(--color-dimmed);
}

footer .content {
    display: flex;
    flex-wrap: wrap;
    align-items: center;
    justify-content: space-between;
    max-width: var(--content-width);
    padding: calc(var(--spacing) * 4) var(--wrapping-padding);
    margin: 0 auto;

    @media (width < 640px) {
        flex-direction: column;
        gap: calc(var(--spacing) * 4);
    }
}

.metadata {
    color: var(--color-text-secondary);
    margin-bottom: 5em;
}

.metadata svg {
    vertical-align: middle;
}

abbr {
    text-decoration: var(--color-text-secondary) dotted underline;
}

blockquote {
    font-style: italic; 
    margin: 0;
    border-left: 4px solid var(--color-surface);
    padding-left: 1em;
}

hr {
    border: none;
    border-top: 1px solid var(--color-surface);
    margin-top: 2.8em;
    margin-bottom: 2.8em;
}

figure {
    display: flex;
    flex-direction: column;
    align-items: center;
    gap: calc(var(--spacing) * 4);
    margin-top: 2.8em;
    margin-bottom: 2.8em;
}

img, figure img {
    max-width: 100%;
    max-height: 50vh;
}

figcaption {
    font-size: .85em;
    text-align: center;
    color: var(--color-text-secondary);
}

article a {
    font-weight: bold;
    color: var(--color-text-primary);
    text-decoration: underline;
}

article a:hover {
    color: var(--color-accent-1);
}

article ol, article ul {
    margin-left: calc(var(--spacing) * 4);

    @media (width <= 40rem) {
        margin-left: calc(var(--spacing) * 2);
    }
}

article ::marker {
    color: var(--color-text-secondary);
}

code {
    font-family: monospace;
    font-size: .8em;
    padding: 3px 6px;
    background: var(--color-dimmed);
}

pre {
    padding: calc(var(--spacing) * 4);
    border-radius: var(--spacing);
    background: var(--color-dimmed);
    margin-top: 2em;
    margin-bottom: 2em;
    max-width: var(--content-width);
    overflow-x: auto;
}

li > pre {
    margin-top: 0.5em;
    margin-bottom: 0.5em;
}

pre > code {
    background: unset;
    padding: unset;
}

p > code {
    word-break: break-word;
}

.table-wrapper {
    display: block;
    overflow-x: auto;
    width: 100%;
}

table {
    width: 100%;
    border-collapse: collapse;
}

td, th {
    border: 1px solid var(--color-surface);
    padding: calc(var(--spacing) * 2) calc(var(--spacing) * 4);
}
